<div class="full-width overflow-hidden">
  <div class="full-width" style="overflow-x: auto">
    <nz-table
      #smallTable
      nzFrontPagination="false"
      nzSize="small"
      nzBordered
      [nzData]="inventory"
      [attr.data-test-element-id]="'inventory-table'"
    >
      <thead>
        <tr>
          <th
            scope="col"
            class="font-14-px label-color header"
            [nzAlign]="'center'"
          >
            {{ entityI18Key | translate }}
          </th>
          <ng-container
            *ngTemplateOutlet="
              header;
              context: { executionStatus: ExecutionStatus.READY }
            "
          ></ng-container>
          <ng-container
            *ngTemplateOutlet="
              headerWhite;
              context: { executionStatus: ExecutionStatus.RUNNING }
            "
          ></ng-container>
          <ng-container
            *ngTemplateOutlet="
              headerWhite;
              context: { executionStatus: ExecutionStatus.SUCCESS }
            "
          ></ng-container>
          @if (!disabledExecutionStatus.includes(ExecutionStatus.SETTLED.id)) {
            <ng-container
              *ngTemplateOutlet="
                header;
                context: { executionStatus: ExecutionStatus.SETTLED }
              "
            ></ng-container>
          }
          <ng-container
            *ngTemplateOutlet="
              headerWhite;
              context: { executionStatus: ExecutionStatus.FAILURE }
            "
          ></ng-container>
          <ng-container
            *ngTemplateOutlet="
              header;
              context: { executionStatus: ExecutionStatus.BLOCKED }
            "
          ></ng-container>
          @if (
            !disabledExecutionStatus.includes(ExecutionStatus.UNTESTABLE.id)
          ) {
            <ng-container
              *ngTemplateOutlet="
                headerWhite;
                context: { executionStatus: ExecutionStatus.UNTESTABLE }
              "
            ></ng-container>
          }

          <th
            class="font-14-px label-color header"
            scope="col"
            [nzAlign]="'center'"
          >
            {{
              'sqtm-core.campaign-workspace.campaign-page.statistics.inventory.planned'
                | translate
            }}
          </th>
          <th
            class="font-14-px label-color header"
            scope="col"
            nz-tooltip
            [nzTooltipTitle]="
              'sqtm-core.campaign-workspace.campaign-page.statistics.inventory.progression.title'
                | translate
            "
            [nzAlign]="'center'"
          >
            {{
              'sqtm-core.campaign-workspace.campaign-page.statistics.inventory.progression.short'
                | translate
            }}
          </th>
        </tr>
      </thead>
      <tbody>
        @for (data of smallTable.data; track data) {
          <tr>
            <td [nzAlign]="'center'">{{ getName(data) }}</td>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: { executionStatus: ExecutionStatus.READY, data: data }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: {
                  executionStatus: ExecutionStatus.RUNNING,
                  data: data
                }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: {
                  executionStatus: ExecutionStatus.SUCCESS,
                  data: data
                }
              "
            ></ng-container>
            @if (
              !disabledExecutionStatus.includes(ExecutionStatus.SETTLED.id)
            ) {
              <ng-container
                *ngTemplateOutlet="
                  cell;
                  context: {
                    executionStatus: ExecutionStatus.SETTLED,
                    data: data
                  }
                "
              >
              </ng-container>
            }
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: {
                  executionStatus: ExecutionStatus.FAILURE,
                  data: data
                }
              "
            ></ng-container>
            <ng-container
              *ngTemplateOutlet="
                cell;
                context: {
                  executionStatus: ExecutionStatus.BLOCKED,
                  data: data
                }
              "
            ></ng-container>
            @if (
              !disabledExecutionStatus.includes(ExecutionStatus.UNTESTABLE.id)
            ) {
              <ng-container
                *ngTemplateOutlet="
                  cell;
                  context: {
                    executionStatus: ExecutionStatus.UNTESTABLE,
                    data: data
                  }
                "
              >
              </ng-container>
            }
            <td
              [nzAlign]="'center'"
              [attr.data-test-element-id]="'total-count'"
            >
              {{ data.total }}
            </td>
            <td
              [nzAlign]="'center'"
              [attr.data-test-element-id]="'execution-rate'"
            >
              {{ data.executionRate }} %
            </td>
          </tr>
        }
      </tbody>
    </nz-table>
  </div>
</div>

<ng-template #header let-executionStatus="executionStatus">
  <th
    scope="col"
    [style.backgroundColor]="executionStatus.color"
    [nzAlign]="'center'"
    class="font-14-px label-color header"
  >
    {{ executionStatus.i18nKey | translate }}
  </th>
</ng-template>

<ng-template #headerWhite let-executionStatus="executionStatus">
  <th
    scope="col"
    [style.backgroundColor]="executionStatus.color"
    [nzAlign]="'center'"
    [style.color]="'white'"
    class="font-14-px header"
  >
    {{ executionStatus.i18nKey | translate }}
  </th>
</ng-template>

<ng-template #cell let-executionStatus="executionStatus" let-data="data">
  <td [attr.data-test-element-id]="executionStatus.id" [nzAlign]="'center'">
    {{ data[executionStatus.id] }}
  </td>
</ng-template>
